<script>
const API = 'https://deckofcardsapi.com/api/deck/new/shuffle/';

export default {
  data() {
    return {
      deckId: undefined,
      dealerCards: [],
      userCards: [],
      image: undefined,
      dealerTotal: 0,
      userTotal: 0,
      draws: 0,
      wins: 0,
      message: "",
      gameOngoing: false,
    }
  },

  computed: {
    cardAPI() {
      return `https://deckofcardsapi.com/api/deck/${this.deckId}/draw/?count=1`
    },
  },

  methods: {
// New deck
    async getDeck() {
      // accessing deck_id variable directly from json
      const {deck_id} = await fetch(API).then((r) => r.json());
      this.deckId = deck_id;
    },

// sets everything back to initial beginning
    async newGame() {
      this.dealerTotal = 0;
      this.userTotal = 0;
      this.userCards = [];
      this.dealerCards = [];
      this.draws = 0;
      this.message = "";
      await this.getDeck();
      await this.drawCard(false, true);
      await this.drawCard(true, true);
      await this.drawCard(true, true);
      this.gameOngoing = true;
    },

// generic sleep -> for dealer draw
    sleep(ms){
      return new Promise((resolve) => {
      setTimeout(resolve, ms);
      });
    },

// if player finished with drawing cards -> dealer can start
    async finish() {
      // draw cards until game finished
      while (this.gameOngoing) {
        await this.sleep(1000);
        await this.drawCard(false, false); 
      }
    },

// Game "logic" checks for game-state
    async gameOver() {
      if (this.userTotal > 21) {
        //LOSE
        this.wins -= 1;
        this.message = "YOU LOST!"
      } else if (this.dealerTotal > 21) {
        //WIN
        this.wins += 1;
        this.message = "CONGRATS, YOU WON!!"
      } else if (this.userTotal > this.dealerTotal) {
        //WIN
        this.wins += 1;
        this.message = "CONGRATS, YOU WON!!"
      } else if (this.userTotal < this.dealerTotal) {
        //LOSE
        this.wins -= 1;
        this.message = "YOU LOST!"
      } else {
        this.message = "IT'S A TIE!"
      }
      this.gameOngoing = false;
    },

    // current points
    cardsToValue(cards) {

      // split cards into aces and non aces for checking if ace = 11 or 1
      const aces = cards.filter(card => card.value === "ACE");
      const nonAces = cards.filter(card => card.value !== "ACE"); 

      let value = 0; 

      // add non aces to the value for Queen, King and Jack -> 10 + for other cards the card.value (number on card)
      nonAces.forEach(function (card) {
        if (card.value === "QUEEN" || card.value === "KING" || card.value === "JACK") {
          value += 10;
        } else {
          value += parseInt(card.value);
        }
      });

      // ace = 1 -> minimun value of ace
      value += aces.length;

      // if possible to add full ace value (11) -> add if not stay with min value (1)
      aces.forEach(function (card) {
        if (value <= 11) {
          value += 10;
        }
      });

      return value;
    },

// Drawing a card, userDraw -> hit me btn, initialDraw -> the 3 cards when game starts
    async drawCard(userDraw, initialDraw) {
      const {cards} = await fetch(this.cardAPI).then((r) => r.json()) // draw a card

      // is it user draw -> if yes add to User Cards, if not add to dealers cards
      userDraw ? this.userCards.push(cards[0]) : this.dealerCards.push(cards[0]);

      // calctulate total + add draws
      if (userDraw) {
        this.userTotal = this.cardsToValue(this.userCards);
        this.draws++;

        // if over 21 -> call gameOver()
        if (this.userTotal > 21) {
          await this.gameOver();
        }
        // dealer draw -> calculate value/total
      } else {
        this.dealerTotal = this.cardsToValue(this.dealerCards);

        // dealer draws until higer or equal to users total
        // filter out initial drawto allow the user to play (-> so game is not over if initial dealer card is higher than initial user card)
        if (this.dealerTotal >= this.userTotal && !initialDraw) {
          await this.gameOver();
        }
      }
    },
  }
}
</script>

<template>
  <div id="mainstyle">

    <div id="gameover" class="flex flex-col justify-center items-center hidden z-30">
      <div class="p-20 mt-8 mx-96 max-w-md border-2 bg-gray-50 rounded">
        <h2 class="bg-gray-50 text-red-600 m-4">Game Over!</h2>
        <button onclick="window.location.reload();"
                class="bg-red-600 hover:bg-red-700 text-white font-bold py-2 px-4 rounded m-4">Try Again
        </button>
      </div>
    </div>

    <main>

      <h1 class="py-10 flex flex-col justify-center items-center"> Black Jack Game </h1>

      <div class="flex flex-col justify-center items-center">
        <p>Get to 21 if possible, but beware to get over it!</p>
        <p>Click on Finish, if you're done drawing!</p>
      </div>

      <div class="cards flex flex-row justify-center items-center mt-4">
        <div v-for="card in dealerCards" id="dealerCards" class="mx-1">
          <img :src="card.image" :alt="card.value" class="w-40"/>
        </div>
      </div>

      <div class="flex flex-row justify-center items-center space-x-4 m-6">
        <button @click="newGame" id="btnGetDeck" v-if="!gameOngoing" class="bg-red-600 hover:bg-red-700 text-white font-bold py-2 px-4 rounded">New Game</button>
        <div v-if="gameOngoing">
          <button @click="drawCard(true, false)" id="btnGetCard"
                  class="bg-red-600 hover:bg-red-700 text-white font-bold py-2 px-4 rounded">Hit Me</button>
          <button @click="finish" id="btnSkipGame" class="bg-red-600 hover:bg-red-700 text-white font-bold py-2 px-4 rounded m-4">Finish</button>
          <br/>
        </div>
      </div>

      <div class="py-0 flex flex-row justify-center items-center space-x-4">
        <h2 id="live">Wins: {{ wins }}</h2>
        <h2>User Points: {{ userTotal }}</h2>
        <h2>Dealer Points: {{ dealerTotal }}</h2>
        <h2>Draws: {{ draws }}</h2>
      </div>

      <div class="cards flex flex-row justify-center items-center mt-4">
        <div v-for="card in userCards" id="cards" class="mx-1">
          <img :src="card.image" :alt="card.value" class="w-40"/>
        </div>
      </div>

      <div v-if="!gameOngoing" class="message py-5 flex justify-center items-center">
        <h1>{{ message }}</h1>
      </div>
      <br/>

    </main>
  </div>
</template>
